/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2005 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.webservice;

import java.io.IOException;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.allesta.wsabi.j2ee.PortComponent;
import org.allesta.wsabi.j2ee.WebServiceDescription;
import org.allesta.wsabi.j2ee.provider.GenericDomainCapableProvider;
import org.allesta.wsabi.j2ee.provider.jonas.JonasProvider;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;

/**
 * @author Vivek Lakshmanan
 */

public class PortComponentsDetailsAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {
		// The webservice description selected by the user.
		String wsdId = p_Request.getParameter("wsdselect");
		// The port component selected by the user.
        String pcId = p_Request.getParameter("pcselect");

		try{
			GenericDomainCapableProvider jonasProvider = new JonasProvider();
			jonasProvider.initialize(m_WhereAreYou.getCurrentJonasServerName(), null);
			WebServiceDescription wsd = jonasProvider.getWebServiceDescription(wsdId);
			PortComponent pc = null;
			for(int i=0; i < wsd.getPortComponentCount(); i++){
				if(wsd.getPortComponent(i).getId().equals(pcId)){
					pc = wsd.getPortComponent(i);
					break;
				}
			}

			// Set the selected description in the request.
			p_Request.setAttribute("selectedWebServiceDescription", wsd);
			p_Request.setAttribute("selectedPortComponent", pc);
			p_Request.setAttribute("implBean", pc.getServiceImplBean());
			HashMap map = new HashMap();
			map.put("wsdselect", wsd.getId());
			map.put("pcselect", pc.getId());
            p_Request.setAttribute("paramMap", map);

            // Force the node selected in tree
			m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_SERVER) + WhereAreYou.NODE_SEPARATOR
		            + "services" + WhereAreYou.NODE_SEPARATOR + "WebService" + WhereAreYou.NODE_SEPARATOR + wsd.getId() + WhereAreYou.NODE_SEPARATOR + pc.getId(), true);
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.

        return (p_Mapping.findForward("PortComponents Details"));
    }



}
